<doxygen xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" version="1.8.13" xsi:noNamespaceSchemaLocation="compound.xsd">
  <compounddef id="group__group__system__config" kind="group">
    <compoundname>group_system_config</compoundname>
    <title>Startup      (System Configuration Files)</title>
    <innergroup refid="group__group__system__config__macro">Macro</innergroup>
    <innergroup refid="group__group__system__config__functions">Functions</innergroup>
    <innergroup refid="group__group__system__config__globals">Global Variables</innergroup>
    <briefdescription>
<para>Provides device startup, system configuration, and linker script files. </para>    </briefdescription>
    <detaileddescription>
<para>The system startup provides the followings features:<itemizedlist>
<listitem><para>See <ref kindref="member" refid="group__group__system__config_1group_system_config_device_initialization">Device Initialization</ref> for the:<itemizedlist>
<listitem><para><ref kindref="member" refid="group__group__system__config_1group_system_config_dual_core_device_initialization">Dual-Core Devices</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__system__config_1group_system_config_single_core_device_initialization">Single-Core Devices</ref></para></listitem></itemizedlist>
</para></listitem><listitem><para><ref kindref="member" refid="group__group__system__config_1group_system_config_device_memory_definition">Device Memory Definition</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__system__config_1group_system_config_heap_stack_config">Heap and Stack Configuration</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__system__config_1group_system_config_default_handlers">Default Interrupt Handlers Definition</ref></para></listitem><listitem><para><ref kindref="member" refid="group__group__system__config_1group_system_config_device_vector_table">Vectors Table Copy from Flash to RAM</ref></para></listitem><listitem><para><ref kindref="compound" refid="group__group__system__config__cm4__functions">Cortex-M4 Control</ref></para></listitem></itemizedlist>
</para>
<para><heading level="1">Configuration Considerations</heading></para>

<para><bold>Device Memory Definition</bold></para>
<para>The flash and RAM allocation for each CPU is defined by the linker scripts. For dual-core devices, the physical flash and RAM memory is shared between the CPU cores. 2 KB of RAM (allocated at the end of RAM) are reserved for system use. For Single-Core devices the system reserves additional 80 bytes of RAM. Using the reserved memory area for other purposes will lead to unexpected behavior.</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The linker files provided with the PDL are generic and handle all common use cases. Your project may not use every section defined in the linker files. In that case you may see warnings during the build process. To eliminate build warnings in your project, you can simply comment out or remove the relevant code in the linker file.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;For the PSoC 64 Secure MCUs devices, refer to the following page: &lt;a href="https://www.cypress.com/documentation/software-and-drivers/psoc-64-secure-mcu-secure-boot-sdk-user-guide"&gt;https://www.cypress.com/documentation/software-and-drivers/psoc-64-secure-mcu-secure-boot-sdk-user-guide&lt;/a&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><bold>ARM GCC</bold><linebreak />
 The flash and RAM sections for the CPU are defined in the linker files: 'xx_yy.ld', where 'xx' is the device group, and 'yy' is the target CPU; for example, 'cy8c6xx7_cm0plus.ld' and 'cy8c6xx7_cm4_dual.ld'. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If the start of the Cortex-M4 application image is changed, the value of the &lt;a href="group__group__system__config__user__settings__macro.html#group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51"&gt;CY_CORTEX_M4_APPL_ADDR&lt;/a&gt; should also be changed. The &lt;a href="group__group__system__config__user__settings__macro.html#group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51"&gt;CY_CORTEX_M4_APPL_ADDR&lt;/a&gt; macro should be used as the parameter for the &lt;a href="group__group__system__config__cm4__functions.html#group__group__system__config__cm4__functions_1gac44c12fdb0562403fc055e4e8966b557"&gt;Cy_SysEnableCM4()&lt;/a&gt; function call. By default, the COMPONENT_CM0P_SLEEP prebuilt image is used for the CM0p core. More about CM0+ prebuilt images, see here: &lt;a href="https://github.com/cypresssemiconductorco/psoc6cm0p"&gt;https://github.com/cypresssemiconductorco/psoc6cm0p&lt;/a&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Change the flash and RAM sizes by editing the macros value in the linker files for both CPUs:</verbatim><itemizedlist>
<listitem><para>'xx_cm0plus.ld', where 'xx' is the device group: <programlisting><codeline><highlight class="normal">flash<sp /><sp /><sp /><sp /><sp /><sp /><sp />(rx)<sp /><sp />:<sp />ORIGIN<sp />=<sp />0x10000000,<sp />LENGTH<sp />=<sp />0x2000</highlight></codeline>
<codeline><highlight class="normal">ram<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(rwx)<sp />:<sp />ORIGIN<sp />=<sp />0x08000000,<sp />LENGTH<sp />=<sp />0x2000</highlight></codeline>
</programlisting></para></listitem><listitem><para>'xx_cm4_dual.ld', where 'xx' is the device group: <programlisting><codeline><highlight class="normal">flash<sp /><sp /><sp /><sp /><sp /><sp /><sp />(rx)<sp /><sp />:<sp />ORIGIN<sp />=<sp />0x10000000,<sp />LENGTH<sp />=<sp />0x100000</highlight></codeline>
<codeline><highlight class="normal">ram<sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp /><sp />(rwx)<sp />:<sp />ORIGIN<sp />=<sp />0x08002000,<sp />LENGTH<sp />=<sp />0x45800</highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para><para>Change the value of the <ref kindref="member" refid="group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51">CY_CORTEX_M4_APPL_ADDR</ref> macro to the ROM ORIGIN's value (0x10000000) + FLASH_CM0P_SIZE value (0x2000, the size of a flash image of the Cortex-M0+ application should be the same value as the flash LENGTH in 'xx_cm0plus.ld') in the 'xx_cm4_dual.ld' file, where 'xx' is the device group. Do this by either:<itemizedlist>
<listitem><para>Passing the following commands to the compiler:<linebreak />
<programlisting><codeline><highlight class="normal">-D<sp />CY_CORTEX_M4_APPL_ADDR=0x10002000<sp /></highlight></codeline>
</programlisting> or</para></listitem><listitem><para>Editing the <ref kindref="member" refid="group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51">CY_CORTEX_M4_APPL_ADDR</ref> value in the 'system_xx.h', where 'xx' is the device family:<linebreak />
<programlisting><codeline><highlight class="normal">#define<sp />CY_CORTEX_M4_APPL_ADDR<sp />(0x10002000u)<sp /></highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para><para><bold>ARM Compiler</bold><linebreak />
 The flash and RAM sections for the CPU are defined in the linker files: 'xx_yy.sct', where 'xx' is the device group, and 'yy' is the target CPU; for example 'cy8c6xx7_cm0plus.sct' and 'cy8c6xx7_cm4_dual.sct'. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If the start of the Cortex-M4 application image is changed, the value of the of the &lt;a href="group__group__system__config__user__settings__macro.html#group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51"&gt;CY_CORTEX_M4_APPL_ADDR&lt;/a&gt; should also be changed. The &lt;a href="group__group__system__config__user__settings__macro.html#group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51"&gt;CY_CORTEX_M4_APPL_ADDR&lt;/a&gt; macro should be used as the parameter for the &lt;a href="group__group__system__config__cm4__functions.html#group__group__system__config__cm4__functions_1gac44c12fdb0562403fc055e4e8966b557"&gt;Cy_SysEnableCM4()&lt;/a&gt; function call. By default, the COMPONENT_CM0P_SLEEP prebuilt image is used for the CM0p core. More about CM0+ prebuilt images, see here: &lt;a href="https://github.com/cypresssemiconductorco/psoc6cm0p"&gt;https://github.com/cypresssemiconductorco/psoc6cm0p&lt;/a&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;The linker files provided with the PDL are generic and handle all common use cases. Your project may not use every section defined in the linker files. In that case you may see the warnings during the build process: L6314W (no section matches pattern) and/or L6329W (pattern only matches removed unused sections). In your project, you can suppress the warning by passing the "--diag_suppress=L6314W,L6329W" option to the linker. You can also comment out or remove the relevant code in the linker file.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Change the flash and RAM sizes by editing the macros value in the linker files for both CPUs:</verbatim><itemizedlist>
<listitem><para>'xx_cm0plus.sct', where 'xx' is the device group: <programlisting><codeline><highlight class="normal">#define<sp />FLASH_START<sp />0x10000000</highlight></codeline>
<codeline><highlight class="normal">#define<sp />FLASH_SIZE<sp /><sp />0x00002000</highlight></codeline>
<codeline><highlight class="normal">#define<sp />RAM_START<sp /><sp /><sp />0x08000000</highlight></codeline>
<codeline><highlight class="normal">#define<sp />RAM_SIZE<sp /><sp /><sp /><sp />0x00002000</highlight></codeline>
</programlisting></para></listitem><listitem><para>'xx_cm4_dual.sct', where 'xx' is the device group: <programlisting><codeline><highlight class="normal">#define<sp />FLASH_START<sp />0x10000000</highlight></codeline>
<codeline><highlight class="normal">#define<sp />FLASH_SIZE<sp /><sp />0x00100000</highlight></codeline>
<codeline><highlight class="normal">#define<sp />RAM_START<sp /><sp /><sp />0x08002000</highlight></codeline>
<codeline><highlight class="normal">#define<sp />RAM_SIZE<sp /><sp /><sp /><sp />0x00045800</highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para><para>Change the value of the <ref kindref="member" refid="group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51">CY_CORTEX_M4_APPL_ADDR</ref> macro to the FLASH_START value (0x10000000) + FLASH_CM0P_SIZE value (0x2000, the size of a flash image of the Cortex-M0+ application should be the same value as the FLASH_SIZE in the 'xx_cm0plus.sct') in the 'xx_cm4_dual.sct' file, where 'xx' is the device group. Do this by either:<itemizedlist>
<listitem><para>Passing the following commands to the compiler:<linebreak />
<programlisting><codeline><highlight class="normal">-D<sp />CY_CORTEX_M4_APPL_ADDR=0x10002000<sp /></highlight></codeline>
</programlisting> or</para></listitem><listitem><para>Editing the <ref kindref="member" refid="group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51">CY_CORTEX_M4_APPL_ADDR</ref> value in the 'system_xx.h', where 'xx' is the device family:<linebreak />
<programlisting><codeline><highlight class="normal">#define<sp />CY_CORTEX_M4_APPL_ADDR<sp />(0x10002000u)<sp /></highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para><para><bold>IAR</bold><linebreak />
 The flash and RAM sections for the CPU are defined in the linker files: 'xx_yy.icf', where 'xx' is the device group, and 'yy' is the target CPU; for example, 'cy8c6xx7_cm0plus.icf' and 'cy8c6xx7_cm4_dual.icf'. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;If the start of the Cortex-M4 application image is changed, the value of the of the &lt;a href="group__group__system__config__user__settings__macro.html#group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51"&gt;CY_CORTEX_M4_APPL_ADDR&lt;/a&gt; should also be changed. The &lt;a href="group__group__system__config__user__settings__macro.html#group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51"&gt;CY_CORTEX_M4_APPL_ADDR&lt;/a&gt; macro should be used as the parameter for the &lt;a href="group__group__system__config__cm4__functions.html#group__group__system__config__cm4__functions_1gac44c12fdb0562403fc055e4e8966b557"&gt;Cy_SysEnableCM4()&lt;/a&gt; function call. By default, the COMPONENT_CM0P_SLEEP prebuilt image is used for the CM0p core. More about CM0+ prebuilt images, see here: &lt;a href="https://github.com/cypresssemiconductorco/psoc6cm0p"&gt;https://github.com/cypresssemiconductorco/psoc6cm0p&lt;/a&gt;&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;Change the flash and RAM sizes by editing the macros value in the linker files for both CPUs:</verbatim><itemizedlist>
<listitem><para>'xx_cm0plus.icf', where 'xx' is the device group: <programlisting><codeline><highlight class="normal">define<sp />symbol<sp />__ICFEDIT_region_IROM1_start__<sp />=<sp />0x10000000;</highlight></codeline>
<codeline><highlight class="normal">define<sp />symbol<sp />__ICFEDIT_region_IROM1_end__<sp /><sp /><sp />=<sp />0x10001FFF;</highlight></codeline>
<codeline><highlight class="normal">define<sp />symbol<sp />__ICFEDIT_region_IRAM1_start__<sp />=<sp />0x08000000;</highlight></codeline>
<codeline><highlight class="normal">define<sp />symbol<sp />__ICFEDIT_region_IRAM1_end__<sp /><sp /><sp />=<sp />0x08001FFF;</highlight></codeline>
</programlisting></para></listitem><listitem><para>'xx_cm4_dual.icf', where 'xx' is the device group: <programlisting><codeline><highlight class="normal">define<sp />symbol<sp />__ICFEDIT_region_IROM1_start__<sp />=<sp />0x10000000;</highlight></codeline>
<codeline><highlight class="normal">define<sp />symbol<sp />__ICFEDIT_region_IROM1_end__<sp /><sp /><sp />=<sp />0x100FFFFF;</highlight></codeline>
<codeline><highlight class="normal">define<sp />symbol<sp />__ICFEDIT_region_IRAM1_start__<sp />=<sp />0x08002000;</highlight></codeline>
<codeline><highlight class="normal">define<sp />symbol<sp />__ICFEDIT_region_IRAM1_end__<sp /><sp /><sp />=<sp />0x080477FF;</highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para><para>Change the value of the <ref kindref="member" refid="group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51">CY_CORTEX_M4_APPL_ADDR</ref> macro to the <bold>ICFEDIT_region_IROM1_start</bold> value (0x10000000) + FLASH_CM0P_SIZE value (0x2000, the size of a flash image of the Cortex-M0+ application) in the 'xx_cm4_dual.icf' file, where 'xx' is the device group. The sum result should be the same as (<bold>ICFEDIT_region_IROM1_end</bold> + 1) value in the 'xx_cm0plus.icf'. Do this by either:<itemizedlist>
<listitem><para>Passing the following commands to the compiler:<linebreak />
<programlisting><codeline><highlight class="normal">-D<sp />CY_CORTEX_M4_APPL_ADDR=0x10002000<sp /></highlight></codeline>
</programlisting> or</para></listitem><listitem><para>Editing the <ref kindref="member" refid="group__group__system__config__user__settings__macro_1ga54e255e631cab1db862ff92646e54c51">CY_CORTEX_M4_APPL_ADDR</ref> value in the 'system_xx.h', where 'xx' is the device family:<linebreak />
<programlisting><codeline><highlight class="normal">#define<sp />CY_CORTEX_M4_APPL_ADDR<sp />(0x10002000u)<sp /></highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para>

<para><bold>Device Initialization</bold></para>
<para>After a power-on-reset (POR), the boot process is handled by the boot code from the on-chip ROM that is always executed by the Cortex-M0+ core. The boot code passes the control to the Cortex-M0+ startup code located in flash.</para>
<para><bold>Dual-Core Devices</bold></para>
<para>The Cortex-M0+ startup code performs the device initialization by a call to <ref kindref="member" refid="group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2">SystemInit()</ref> and then calls the main() function. The Cortex-M4 core is disabled by default. Enable the core using the <ref kindref="member" refid="group__group__system__config__cm4__functions_1gac44c12fdb0562403fc055e4e8966b557">Cy_SysEnableCM4()</ref> function. See <ref kindref="compound" refid="group__group__system__config__cm4__functions">Cortex-M4 Control</ref> for more details. <verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Startup code executes &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2"&gt;SystemInit()&lt;/a&gt; function for the both Cortex-M0+ and Cortex-M4 cores. The function has a separate implementation on each core. Both function implementations unlock and disable the WDT. Therefore enable the WDT after both cores have been initialized.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><bold>Single-Core Devices</bold></para>
<para>The Cortex-M0+ core is not user-accessible on these devices. In this case the Flash Boot handles setup of the CM0+ core and starts the Cortex-M4 core.</para>


<para><bold>Heap and Stack Configuration</bold></para>
<para>There are two ways to adjust heap and stack configurations:<orderedlist>
<listitem><para>Editing source code files</para></listitem><listitem><para>Specifying via command line</para></listitem></orderedlist>
</para><para>By default, the stack size is set to 0x00001000 and the heap size is allocated dynamically to the whole available free memory up to stack memory and it is set to the 0x00000400 (for ARM GCC and IAR compilers) as minimal value.</para>
<para><bold>ARM GCC</bold></para>
<para><itemizedlist>
<listitem><para><bold>Editing source code files</bold><linebreak />
 The heap and stack sizes are defined in the assembler startup files (e.g. startup_psoc6_01_cm0plus.S and startup_psoc6_01_cm4.S). Change the heap and stack sizes by modifying the following lines:<linebreak />
<programlisting><codeline><highlight class="normal">.equ<sp /><sp />Stack_Size,<sp />0x00001000<sp /></highlight></codeline>
</programlisting> <programlisting><codeline><highlight class="normal">.equ<sp /><sp />Heap_Size,<sp /><sp />0x00000400<sp /></highlight></codeline>
</programlisting> Also, the stack size is defined in the linker script files: 'xx_yy.ld', where 'xx' is the device family, and 'yy' is the target CPU; for example, cy8c6xx7_cm0plus.ld and cy8c6xx7_cm4_dual.ld. Change the stack size by modifying the following line:<linebreak />
<programlisting><codeline><highlight class="normal">STACK_SIZE<sp />=<sp />0x1000;<sp /></highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para><para><verbatim>embed:rst 
.. raw:: html

  &lt;div class="admonition note"&gt;&lt;p class="admonition-title"&gt;note&lt;/p&gt;&lt;p&gt;&lt;p&gt;Correct operation of malloc and related functions depends on the working implementation of the 'sbrk' function. Newlib-nano (default C runtime library used by the GNU Arm Embedded toolchain) provides weak 'sbrk' implementation that doesn't check for heap and stack collisions during excessive memory allocations. To ensure the heap always remains within the range defined by __HeapBase and __HeapLimit linker symbols, provide a strong override for the 'sbrk' function: &lt;div class="highlight-default notranslate"&gt;&lt;div class="highlight"&gt;&lt;pre&gt;void&lt;/pre&gt;&lt;pre&gt;&lt;span /&gt;*&lt;span /&gt;_sbrk(uint32_t&lt;span /&gt;incr)&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;{&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;pre&gt;extern&lt;/pre&gt;&lt;pre&gt;&lt;span /&gt;uint8_t&lt;span /&gt;__HeapBase,&lt;span /&gt;__HeapLimit;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;pre&gt;static&lt;/pre&gt;&lt;pre&gt;&lt;span /&gt;uint8_t&lt;span /&gt;*heapBrk&lt;span /&gt;=&lt;span /&gt;&amp;amp;__HeapBase;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;uint8_t&lt;span /&gt;*prevBrk&lt;span /&gt;=&lt;span /&gt;heapBrk;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;pre&gt;if&lt;/pre&gt;&lt;pre&gt;&lt;span /&gt;(incr&lt;span /&gt;&amp;gt;&lt;span /&gt;(uint32_t)(&amp;amp;__HeapLimit&lt;span /&gt;-&lt;span /&gt;heapBrk))&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;{&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;errno&lt;span /&gt;=&lt;span /&gt;ENOMEM;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;pre&gt;return&lt;/pre&gt;&lt;pre&gt;&lt;span /&gt;(&lt;/pre&gt;&lt;pre&gt;void&lt;/pre&gt;&lt;pre&gt;&lt;span /&gt;*)-1;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;}&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;heapBrk&lt;span /&gt;+=&lt;span /&gt;incr;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;span /&gt;&lt;/pre&gt;&lt;pre&gt;return&lt;/pre&gt;&lt;pre&gt;&lt;span /&gt;prevBrk;&lt;/pre&gt;&lt;/div&gt;&lt;div class="highlight"&gt;&lt;pre&gt;}&lt;/pre&gt;&lt;/div&gt;&lt;/div&gt; For FreeRTOS-enabled multi-threaded applications, it is sufficient to include clib-support library that provides newlib-compatible implementations of 'sbrk', '__malloc_lock' and '__malloc_unlock': &lt;br /&gt; &lt;a href="https://github.com/cypresssemiconductorco/clib-support"&gt;https://github.com/cypresssemiconductorco/clib-support&lt;/a&gt;.&lt;/p&gt;&lt;/p&gt;&lt;/div&gt;</verbatim></para>

<para><bold>ARM Compiler</bold></para>
<para><itemizedlist>
<listitem><para><bold>Editing source code files</bold><linebreak />
 The stack size is defined in the linker script files: 'xx_yy.sct', where 'xx' is the device family, and 'yy' is the target CPU; for example, cy8c6xx7_cm0plus.sct and cy8c6xx7_cm4_dual.sct. Change the stack size by modifying the following line:<linebreak />
<programlisting><codeline><highlight class="normal">STACK_SIZE<sp />=<sp />0x1000;<sp /></highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para>

<para><bold>IAR</bold></para>
<para><itemizedlist>
<listitem><para><bold>Editing source code files</bold><linebreak />
 The heap and stack sizes are defined in the linker script files: 'xx_yy.icf', where 'xx' is the device family, and 'yy' is the target CPU; for example, cy8c6xx7_cm0plus.icf and cy8c6xx7_cm4_dual.icf. Change the heap and stack sizes by modifying the following lines:<linebreak />
<programlisting><codeline><highlight class="normal">Stack_Size<sp /><sp /><sp /><sp /><sp /><sp />EQU<sp /><sp /><sp /><sp /><sp />0x00001000<sp /></highlight></codeline>
</programlisting> <programlisting><codeline><highlight class="normal">Heap_Size<sp /><sp /><sp /><sp /><sp /><sp /><sp />EQU<sp /><sp /><sp /><sp /><sp />0x00000400<sp /></highlight></codeline>
</programlisting></para></listitem><listitem><para><bold>Specifying via command line</bold><linebreak />
 Change the heap and stack sizes passing the following commands to the linker (including quotation marks):<linebreak />
<programlisting><codeline><highlight class="normal">--define_symbol<sp />__STACK_SIZE=0x000000400<sp /></highlight></codeline>
</programlisting> <programlisting><codeline><highlight class="normal">--define_symbol<sp />__HEAP_SIZE=0x000000100<sp /></highlight></codeline>
</programlisting></para></listitem></itemizedlist>
</para>


<para><bold>Default Interrupt Handlers Definition</bold></para>
<para>The default interrupt handler functions are defined as weak functions to a dummy handler in the startup file. The naming convention for the interrupt handler names is &lt;interrupt_name&gt;_IRQHandler. A default interrupt handler can be overwritten in user code by defining the handler function using the same name. For example: <programlisting><codeline><highlight class="normal"><sp />void<sp />scb_0_interrupt_IRQHandler(void)</highlight></codeline>
<codeline><highlight class="normal">{</highlight></codeline>
<codeline><highlight class="normal"><sp /><sp /><sp /><sp />...</highlight></codeline>
<codeline><highlight class="normal">}</highlight></codeline>
</programlisting></para>

<para><bold>Vectors Table Copy from Flash to RAM</bold></para>
<para>This process uses memory sections defined in the linker script. The startup code actually defines the contents of the vector table and performs the copy. </para>
<para><bold>ARM GCC</bold></para>
<para>The linker script file is 'xx_yy.ld', where 'xx' is the device family, and 'yy' is the target CPU; for example, cy8c6xx7_cm0plus.ld and cy8c6xx7_cm4_dual.ld. It defines sections and locations in memory.<linebreak />
 Copy interrupt vectors from flash to RAM: <linebreak />
 From:<programlisting><codeline><highlight class="normal">LONG<sp />(__Vectors)<sp /></highlight></codeline>
</programlisting> To:<programlisting><codeline><highlight class="normal">LONG<sp />(__ram_vectors_start__)<sp /></highlight></codeline>
</programlisting> Size:<programlisting><codeline><highlight class="normal">LONG<sp />(__Vectors_End<sp />-<sp />__Vectors)<sp /></highlight></codeline>
</programlisting> The vector table address (and the vector table itself) are defined in the assembler startup files (e.g. startup_psoc6_01_cm0plus.S and startup_psoc6_01_cm4.S). The code in these files copies the vector table from Flash to RAM. </para>

<para><bold>ARM Compiler</bold></para>
<para>The linker script file is 'xx_yy.sct', where 'xx' is the device family, and 'yy' is the target CPU; for example, cy8c6xx7_cm0plus.sct and cy8c6xx7_cm4_dual.sct. The linker script specifies that the vector table (RESET_RAM) shall be first in the RAM section.<linebreak />
 RESET_RAM represents the vector table. It is defined in the assembler startup files (e.g. startup_psoc6_01_cm0plus.s and startup_psoc6_01_cm4.s). The code in these files copies the vector table from Flash to RAM.</para>

<para><bold>IAR</bold></para>
<para>The linker script file is 'xx_yy.icf', where 'xx' is the device family, and 'yy' is the target CPU; for example, cy8c6xx7_cm0plus.icf and cy8c6xx7_cm4_dual.icf. This file defines the .intvec_ram section and its location. <programlisting><codeline><highlight class="normal">place<sp />at<sp />start<sp />of<sp />IRAM1_region<sp /><sp />{<sp />readwrite<sp />section<sp />.intvec_ram};<sp /></highlight></codeline>
</programlisting> The vector table address (and the vector table itself) are defined in the assembler startup files (e.g. startup_psoc6_01_cm0plus.s and startup_psoc6_01_cm4.s). The code in these files copies the vector table from Flash to RAM.</para>



<para><heading level="1">MISRA Compliance</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;MISRA Rule &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Class (Required/Advisory) &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Rule Description &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Description of Deviation(s)  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.3 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;R &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The character sequence // shall not be used within a comment. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;The comments provide a useful WEB link to the documentation.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>

<para><heading level="1">Changelog</heading></para>
<para><verbatim>embed:rst 
.. raw:: html

  &lt;table class="docutils align-default"&gt;&lt;tr&gt;&lt;td class="head"&gt;&lt;p&gt;Version &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Changes &lt;/p&gt;&lt;/td&gt;&lt;td class="head"&gt;&lt;p&gt;Reason for Change  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.80 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated linker scripts for PSoC 64 Secure MCU devices. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated FLASH and SRAM memory area definitions in cyb0xxx linker script templates in accordance with the PSoC 64 Secure Boot SDK policies.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added &lt;a href="group__group__pra__functions.html#group__group__pra__functions_1ga93393c7e6e2ca124ac0b331dcee6e78b"&gt;Cy_PRA_Init()&lt;/a&gt; function call to &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2"&gt;SystemInit()&lt;/a&gt; API for CM0+ core of PSoC 64 Secure MCU. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated PSoC 64 Secure MCU startup sequence to initialize the Protected Register Access driver.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.70.1 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated documentation for the better description of the existing startup implementation. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;User experience enhancement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="5"&gt;&lt;p&gt;2.70 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1gae0c36a9591fe6e9c45ecb21a794f0f0f"&gt;SystemCoreClockUpdate()&lt;/a&gt; implementation - The SysClk API is reused. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Code optimization.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2"&gt;SystemInit()&lt;/a&gt; implementation - The IPC7 structure is initialized for both cores. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Provided support for SysPM driver updates.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated the linker scripts. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Reserved FLASH area for the MCU boot headers.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added System Pipe initialization for all devices.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Improved PDL usability according to user experience.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Removed redundant legacy macros: CY_CLK_EXT_FREQ_HZ, CY_CLK_ECO_FREQ_HZ and CY_CLK_ALTHF_FREQ_HZ. Use &lt;a href="group__group__sysclk__ext__funcs.html#group__group__sysclk__ext__funcs_1gad4b77c61d47878007b5c50e3baf13e51"&gt;Cy_SysClk_ExtClkSetFrequency&lt;/a&gt;, &lt;a href="group__group__sysclk__eco__funcs.html#group__group__sysclk__eco__funcs_1ga9d94ac55503404a0bdaf017fe33ecdbd"&gt;Cy_SysClk_EcoConfigure&lt;/a&gt; and &lt;a href="group__group__ble__clk__functions.html#group__group__ble__clk__functions_1gae92f61cd532c63d9547c52ccd6757ff7"&gt;Cy_BLE_EcoConfigure&lt;/a&gt; functions instead them.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Defect fixing.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.60 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated linker scripts. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Provided support for new devices, updated usage of CM0p prebuilt image.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.50 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated assembler files, C files, linker scripts. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Dynamic allocated HEAP size for Arm Compiler 6, IAR 8.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.40 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Updated assembler files, C files, linker scripts. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added Arm Compiler 6 support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.30 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added assembler files, linker scripts for Mbed OS. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added Arm Mbed OS embedded operating system support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated linker scripts to extend the Flash and Ram memories size available for the CM4 core. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Enhanced PDL usability.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;2.20 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Moved the Cy_IPC_SystemSemaInit(), Cy_IPC_SystemPipeInit() functions implementation from IPC to Startup. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Changed the IPC driver configuration method from compile time to run time.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="2"&gt;&lt;p&gt;2.10 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added constructor attribute to &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2"&gt;SystemInit()&lt;/a&gt; function declaration for ARM MDK compiler. &lt;br /&gt; Removed $Sub$$main symbol for ARM MDK compiler.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;uVision Debugger support.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Updated description of the Startup behavior for Single-Core Devices. &lt;br /&gt; Added note about WDT disabling by &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2"&gt;SystemInit()&lt;/a&gt; function.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Documentation improvement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td rowspan="4"&gt;&lt;p&gt;2.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Added restoring of FLL registers to the default state in &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2"&gt;SystemInit()&lt;/a&gt; API for single core devices. Single core device support.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added Normal Access Restrictions, Public Key, TOC part2 and TOC part2 copy to Supervisory flash linker memory regions. &lt;br /&gt; Renamed 'wflash' memory region to 'em_eeprom'.  &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Linker scripts usability improvement.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added Cy_IPC_SystemSemaInit(), Cy_IPC_SystemPipeInit(), &lt;a href="group__group__flash__functions.html#group__group__flash__functions_1gaf1b44a029169a1baa08e211bff714a19"&gt;Cy_Flash_Init()&lt;/a&gt; functions call to &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2"&gt;SystemInit()&lt;/a&gt; API. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Reserved system resources for internal operations.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;Added clearing and releasing of IPC structure #7 (reserved for the Deep-Sleep operations) to &lt;a href="group__group__system__config__system__functions.html#group__group__system__config__system__functions_1ga93f514700ccf00d08dbdcff7f1224eb2"&gt;SystemInit()&lt;/a&gt; API. &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;To avoid deadlocks in case of SW or WDT reset during Deep-Sleep entering.  &lt;/p&gt;&lt;/td&gt;&lt;/tr&gt;&lt;tr&gt;&lt;td&gt;&lt;p&gt;1.0 &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p&gt;Initial version &lt;/p&gt;&lt;/td&gt;&lt;td&gt;&lt;p /&gt;&lt;/td&gt;&lt;/tr&gt;&lt;/table&gt;</verbatim></para>
    </detaileddescription>
  </compounddef>
</doxygen>